#include "R.h"

////////////////////////////////////////////

#define right_rotate 5.0f * PHI_F / 180.0f;
#define left_rotate -5.0f * PHI_F / 180.0f;

////////////////////////////////////////////

class C_PC{

	int count;
	float V;
	int PrevMotion;
	float PlayTime[4];

public:

	void Init( void );
	void CharaMove( char KeyBuf[256] );
	void MotionInIt( void );
	void MotionHandle( char KeyBuf[256] );
	void MotionAttach( int Handle );

};

//////////////////////////////////////////////////////

void C_PC::Init( void )
{

	count = 0;
	sPC.Handle[0] = MV1LoadModel("model\\pc\\woman.x");
	MV1SetScale(sPC.Handle[0], VGet(0.005f, 0.005f, 0.005f));

}

///////////////////////////////////////////////////////

void C_PC::CharaMove( char KeyBuf[256] )
{
	int Motion = 0;
	int Rotate = 0;
	sPC.PosB = sPC.Pos;

	//Oړ
	if(KeyBuf[KEY_INPUT_W] == 1)
	{
		sPC.y_r += sCam.y_r;
		sCam.y_r = 0.0f;
		Rotate = 0;
		//RcfỶ]lZbg
		MV1SetRotationXYZ( sPC.Handle[0], VGet( 0, sPC.y_r, 0 ) );
		
		if(KeyBuf[KEY_INPUT_LSHIFT] == 1)
		{
			Motion = 1;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r - PHI_F / 2)) ) );
					break;
			}

		} else {
			Motion = 2;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r - PHI_F / 2)) ) );
					break;
			}
		}

	}
	if(KeyBuf[KEY_INPUT_S] == 1)
	{
		sPC.y_r += sCam.y_r;
		sCam.y_r = 0.0f;
		Rotate = 2;
		//RcfỶ]lZbg
		MV1SetRotationXYZ( sPC.Handle[0], VGet( 0, sPC.y_r, 0 ) ) ;

		if(KeyBuf[KEY_INPUT_LSHIFT] == 1)
		{
			Motion = 1;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r - PHI_F)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r - 3 * PHI_F / 2)) ) );
					break;
			}
		} else {
			Motion = 2;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r - PHI_F)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r - 3 * PHI_F / 2)) ) );
					break;
			}
		}

	}
	//ړ
	if(KeyBuf[KEY_INPUT_A] == 1)
	{
		sPC.y_r += sCam.y_r;
		sCam.y_r = 0.0f;
		Rotate = -1;

		if(KeyBuf[KEY_INPUT_LSHIFT] == 1)
		{
			Motion = 1;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r - PHI_F / 2)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r - PHI_F)) ) );
					break;
			}
		} else {
			Motion = 2;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r - PHI_F / 2)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r - PHI_F)) ) );
					break;
			}
		}

	}

	if(KeyBuf[KEY_INPUT_D] == 1)
	{
		sPC.y_r += sCam.y_r;
		sCam.y_r = 0.0f;
		Rotate = 1;

		if(KeyBuf[KEY_INPUT_LSHIFT] == 1)
		{
			Motion = 1;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r + PHI_F / 2)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -1.0f), MGetRotY(sPC.y_r)) ) );
					break;
			}
		} else {
			Motion = 2;
			switch(sPC.MapHit.HitFlag)
			{
				case 0:
					sPC.Pos = VAdd( sPC.Pos, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r + PHI_F / 2)) );
					break;

				case 1:
					sPC.Pos = VAdd( sPC.Pos, VCross( sPC.MapHit.Normal, VTransform(VGet(0.0f, 0.0f, -2.5f), MGetRotY(sPC.y_r)) ) );
					break;
			}
		}

	}

	//y]
	if(KeyBuf[KEY_INPUT_RIGHT] == 1)
	{
		sPC.y_r += right_rotate;
		if( sPC.y_r > Phi )	sPC.y_r -= Phi;
	}
	if(KeyBuf[KEY_INPUT_LEFT] == 1)
	{
		sPC.y_r += left_rotate;
		if(sPC.y_r < 0.0f)	sPC.y_r += Phi;
	}

	if( sPC.MapHit.HitFlag == 1 )
	{
		if(KeyBuf[KEY_INPUT_SPACE] == 1)
		{
			count = 1;
			V = 1.25f;
		} else {
			V = 0.0f;
			count = 0;
		}
	} else {
		count++;
	}

	sPC.Pos.y += V - 0.5f * G * count / 50.0f;

	sPC.Pos = VGet( sPC.Pos.x, sPC.Pos.y, sPC.Pos.z );
					
	//RcfỶ]lZbg
	MV1SetRotationXYZ( sPC.Handle[0], VGet( 0, sPC.y_r + Rotate * PHI_F / 2, 0 ) );

	sPC.Motion = Motion;
}

///////////////////////////////////////////////////////////////////////////

void C_PC::MotionInIt( void )
{
	sPC.M_Handle[0] = MV1AttachAnim( sPC.Handle[0], 0, -1, FALSE );
	sPC.Mot_Time[0] = MV1GetAttachAnimTotalTime( sPC.Handle[0], sPC.M_Handle[0] );
	PlayTime[0] = 0.0f;
}

///////////////////////////////////////////////////////////////////////////

void C_PC::MotionHandle( char KeyBuf[256] )
{
	if( KeyBuf[KEY_INPUT_0] == 1 )
	{
		sPC.Motion = 3;
	}
}
///////////////////////////////////////////////////////////////////////////

void C_PC::MotionAttach( int Handle )
{
	if( PrevMotion != Handle )
	{
		MV1DetachAnim( sPC.Handle[0], sPC.M_Handle[PrevMotion] );
		sPC.M_Handle[Handle] = MV1AttachAnim( sPC.Handle[0], Handle, -1, FALSE );
		sPC.Mot_Time[Handle] = MV1GetAttachAnimTotalTime( sPC.Handle[0], sPC.M_Handle[Handle] );
		PlayTime[Handle] = 0.0f;
	}

		switch(Handle)
		{
			case 0:
				PlayTime[Handle] += 0.75f;
				break;
			case 1:
				PlayTime[Handle] += 0.75f;
				break;
			case 2:
				PlayTime[Handle] += 0.75f;
				break;
			case 3:
				PlayTime[Handle] += 0.75f;
				break;
		}

	// ĐԂAj[V̑ĐԂɒBĐԂOɖ߂
	if( PlayTime[Handle] >= sPC.Mot_Time[Handle] )
	{
		switch(Handle)
		{
			case 0:
				PlayTime[Handle] = 0.0f;
				break;
			case 1:
				PlayTime[Handle] = 0.0f;
				break;
			case 2:
				PlayTime[Handle] = 0.0f;
				break;
			case 3:
				PlayTime[Handle] = sPC.Mot_Time[Handle];
				break;
		}
	}
	MV1SetAttachAnimTime( sPC.Handle[0], sPC.M_Handle[Handle], PlayTime[Handle] );
	PrevMotion = Handle;

}

//////////////////////////////////////////////////////////////////////////////////////////////

class C_NPC{

	int StairB, PosB;

public:

	void InIt( int Stair, int Pos );
	void SetPos( int Stair, int Pos );
	void Draw( void );
	void Motion( void );
	void Action( void );
};

//////////////////////////////////////////////////////////////////////////////////////////////

void C_NPC::InIt( int Stair, int Pos )
{
	sNPC.Handle[0] = MV1DuplicateModel( sPC.Handle[0] );
	MV1SetScale(sNPC.Handle[0], VGet(0.005f, 0.005f, 0.005f));
	switch(Stair)
	{
		case 0:
			switch(Pos)
			{
				case 0:
					MV1SetPosition( sNPC.Handle[0], VGet( 141.0f, 29.0f, 187.0f ) );
					break;
			}
			break;
	}

}

//////////////////////////////////////////////////////////////////////////////////////////////

void C_NPC::SetPos( int Stair, int Pos )
{
	if( ( Stair != StairB ) || ( Pos != PosB ) )
	{
		switch(Stair)
		{
			case 0:
				switch(Pos)
				{
					case 0:
						MV1SetPosition( sNPC.Handle[0], VGet( 141.0f, 29.0f, 187.0f ) );
						break;
				}
				break;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////

void C_NPC::Draw( void )
{
	MV1DrawModel( sNPC.Handle[0] );
}

//////////////////////////////////////////////////////////////////////////////////////////////

void C_NPC::Motion( void )
{
}

//////////////////////////////////////////////////////////////////////////////////////////////

void C_NPC::Action( void )
{
}

//////////////////////////////////////////////////////////////////////////////////////////////

class C_Map{

	VECTOR Pos;
	MV1_COLL_RESULT_POLY MapHit;
	string MDAd, MDType, Stair, MD;

public:

	void Init( void );
	MV1_COLL_RESULT_POLY CheckHit_Ground( VECTOR PosSub, VECTOR PosEnd );

};

////////////////////////////////////////////////////////////////////////////////////////////////

void C_Map::Init()
{

	Pos.x = 0.0f;
	Pos.y = 0.0f;
	Pos.z = 0.0f;

	MDAd = "model\\map\\map0";
	MDType = ".mqo";
	Stair = sPC.Stair;
	MD = MDAd + MDType;
	sMap.Handle[0] = MV1LoadModel( MD.c_str() );
	sMap.Handle[1] = MV1LoadModel("model\\build\\build.0.0.mqo");

	MV1SetPosition( sMap.Handle[0], VGet( Pos.x, Pos.y, Pos.z ) );
	MV1SetupCollInfo( sMap.Handle[0], -1, 4, 4, 2 );

	MV1SetScale( sMap.Handle[1], VGet(0.5f, 0.5f, 0.5f) );
	MV1SetPosition( sMap.Handle[1], VGet( Pos.x, Pos.y, Pos.z ) );
	MV1SetupCollInfo( sMap.Handle[1], -1, 4, 4, 2 );

	//Cgݒ
	ChangeLightTypeDir( VGet(0.0f, -1.0f, 0.0f ) );
}

///////////////////////////////////////////////////////////////////////////////////////////////

MV1_COLL_RESULT_POLY C_Map::CheckHit_Ground( VECTOR PosStart, VECTOR PosEnd )
{
	MV1RefreshCollInfo( sMap.Handle[0], -1 ) ;

	MapHit = MV1CollCheck_Line( sMap.Handle[0], -1,  PosStart,  PosEnd );

	if( MapHit.HitFlag == 1 )
	{
		sPC.Pos = VAdd( MapHit.HitPosition, VScale( MapHit.Normal, 0.01f ) );
		MV1SetPosition( sPC.Handle[0], sPC.Pos);
	} else {
		MV1SetPosition( sPC.Handle[0], PosEnd );
	}
	return MapHit;
}